

lc = 0.5;

dx = 0.1;
dy = 0.1;
dz = 0.05;

nx = 40;
ny = 40;
nz = 1;

cx = dx / nx;
cy = dy / ny;
cz = dz / nz;

Point(1) = {0.0,0.0,0.0,lc};
Point(2) = {dx,0.0,0.0,lc};
Point(3) = {dx,dy,0.0,lc};
Point(4) = {0.0,dy,0.0,lc};

Point(5) = {dx*0.5,dy*0.5,0.0,lc};

Point(6) = {dx*0.333,dy*0.333,0.0,lc};
Point(7) = {dx*0.333,dy*0.666,0.0,lc};
Point(8) = {dx*0.666,dy*0.666,0.0,lc};
Point(9) = {dx*0.666,dy*0.333,0.0,lc};

Point(10) = {0.0,dy*0.333,0.0,lc};
Point(11) = {dx,dy*0.333,0.0,lc};

Point(12) = {0.0,dy*0.666,0.0,lc};
Point(13) = {dx,dy*0.666,0.0,lc};

Point(14) = {dx*0.333,0,0.0,lc};
Point(15) = {dx*0.333,dy,0.0,lc};

Point(16) = {dx*0.666,0,0.0,lc};
Point(17) = {dx*0.666,dy,0.0,lc};

Line(1) = {4,15};
Line(2) = {15,7};
Line(3) = {7,12};
Line(4) = {12,4};
Line(5) = {15,17};
Line(6) = {17,8};
Line(7) = {8,7};
Line(8) = {17,3};
Line(9) = {3,13};
Line(10) = {13,8};
Line(11) = {8,9};
Line(12) = {9,11};
Line(13) = {11,13};
Line(14) = {9,16};
Line(15) = {16,2};
Line(16) = {2,11};
Line(17) = {9,6};
Line(18) = {6,14};
Line(19) = {14,16};
Line(20) = {6,7};
Line(21) = {12,10};
Line(22) = {10,6};
Line(23) = {10,1};
Line(24) = {1,14};
Line Loop(25) = {8,9,10,-6};
Plane Surface(26) = {25};
Line Loop(27) = {13,10,11,12};
Plane Surface(28) = {27};
Line Loop(29) = {7,-2,5,6};
Plane Surface(30) = {29};
Line Loop(31) = {1,2,3,4};
Plane Surface(32) = {31};
Line Loop(33) = {11,17,20,-7};
Plane Surface(34) = {33};
Line Loop(35) = {14,15,16,-12};
Plane Surface(36) = {35};
Line Loop(37) = {17,18,19,-14};
Plane Surface(38) = {37};
Line Loop(39) = {24,-18,-22,23};
Plane Surface(40) = {39};
Line Loop(41) = {21,22,20,3};
Plane Surface(42) = {41};

Transfinite Line {9,8,6,10,13,12,11,14,16,15,19,17,18,22,20,7,2,5,1,3,4,21,23,24} = (nx + ny) * 0.1666 + 1 Using Progression 1.0;
Transfinite Surface {26} = {17,3,13,8};
Transfinite Surface {28} = {8,13,11,9};
Transfinite Surface {36} = {9,11,2,16};
Transfinite Surface {38} = {9,16,14,6};
Transfinite Surface {34} = {8,9,6,7};
Transfinite Surface {30} = {17,8,7,15};
Transfinite Surface {32} = {15,7,12,4};
Transfinite Surface {42} = {12,7,6,10};
Transfinite Surface {40} = {10,6,14,1};
Recombine Surface {26,30,32,42,34,28,36,38,40};

fluid0a[] = Extrude {0,0,dz} {
  Surface {26};
  Layers {nz};
  Recombine;
};

fluid0b[] = Extrude {0,0,dz} {
  Surface {28};
  Layers {nz};
  Recombine;
};

fluid0c[] = Extrude {0,0,dz} {
  Surface {30};
  Layers {nz};
  Recombine;
};

fluid0d[] = Extrude {0,0,dz} {
  Surface {32};
  Layers {nz};
  Recombine;
};

fluid0e[] = Extrude {0,0,dz} {
  Surface {36};
  Layers {nz};
  Recombine;
};

fluid0f[] = Extrude {0,0,dz} {
  Surface {38};
  Layers {nz};
  Recombine;
};

fluid0g[] = Extrude {0,0,dz} {
  Surface {40};
  Layers {nz};
  Recombine;
};

fluid0h[] = Extrude {0,0,dz} {
  Surface {42};
  Layers {nz};
  Recombine;
};

fluid1[] = Extrude {0,0,dz} {
  Surface {34};
  Layers {nz};
  Recombine;
};

// Top
Physical Surface(241) = {51,103,117};
// Left
Physical Surface(242) = {129,205,195};
// Right 
Physical Surface(243) = {55,73,147};
// Bottom
Physical Surface(244) = {183,169,143};
// Front and Back
Physical Surface(245) = {130,32,30,108,64,26,86,28,34,152,240,42,218,40,196,38,36,174};

Physical Volume(300) = {fluid0a[1], fluid0b[1], fluid0c[1], fluid0d[1], fluid0e[1], fluid0f[1], fluid0g[1], fluid0h[1]};
Physical Volume(301) = {fluid1[1]};

