

n = 10;

dimx = 1.0;
dimy = 1.0;
dimz = 0.5;

Point(1) = {0, 0, 0, 0.1};
Point(2) = {dimx, 0, 0, 0.1};
Point(3) = {dimx, dimy, 0, 0.1};
Point(4) = {0, dimy, 0, 0.1};

Point(5) = {dimx*0.5, 0, 0, 0.1};
Point(6) = {dimx, dimy*0.75, 0, 0.1};
Point(7) = {dimx*0.5, dimy, 0, 0.1};
Point(8) = {0, dimy*0.75, 0, 0.1};

Point(9) = {dimx*0.5, dimy*0.75, 0, 0.1};

Line(1) = {1,8};
Line(2) = {8,9};
Line(3) = {9,5};
Line(4) = {5,1};
Line(5) = {5,2};
Line(6) = {2,6};
Line(7) = {6,9};
Line(8) = {6,3};
Line(9) = {3,7};
Line(10) = {7,9};
Line(11) = {7,4};
Line(12) = {4,8};

Line Loop(13) = {10,-2,-12,-11};
Plane Surface(14) = {13};
Line Loop(15) = {7,-10,-9,-8};
Plane Surface(16) = {15};
Line Loop(17) = {3,5,6,7};
Plane Surface(18) = {17};
Line Loop(19) = {2,3,4,1};
Plane Surface(20) = {19};

Transfinite Line {12,10,8} = 0.25*n+1 Using Progression 1.0;
Transfinite Line {1,3,6} = 0.75*n+1 Using Progression 1.0;
Transfinite Line {9,7,5} = 0.5*n+1 Using Progression 1.0;
Transfinite Line {4,2,11} = 0.5*n+1 Using Progression 1.0;

Transfinite Surface {14} = {7,4,8,9};
Transfinite Surface {20} = {8,1,5,9};
Transfinite Surface {18} = {6,9,5,2};
Transfinite Surface {16} = {6,3,7,9};

Recombine Surface {14,16,18,20};

out1[] = Extrude {0,0,dimz} { 
Surface{14}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out2[] = Extrude {0,0,dimz} { 
Surface{16}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out3[] = Extrude {0,0,dimz} { 
Surface{18}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out4[] = Extrude {0,0,dimz} { 
Surface{20}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out5[] = Extrude {0,0,dimz} { 
Surface{42}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out6[] = Extrude {0,0,dimz} { 
Surface{64}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out7[] = Extrude {0,0,dimz} { 
Surface{108}; 
Layers { 0.5*n }; 
Recombine; 
}; 

out8[] = Extrude {0,0,dimz} { 
Surface{86}; 
Layers { 0.5*n }; 
Recombine; 
}; 

// Top 
Physical Surface(140) = {59,147,41,129};

// Bottom
Physical Surface(141) = {169,187,103,77};

// Left
Physical Surface(142) = {173,125,37,107};

// Right
Physical Surface(143) = {151,63,81,191};

// Front
Physical Surface(144) = {174,130,152,196};

// Back
Physical Surface(145) = {18,20,14,16};

Physical Volume(150) = {out1[1], out2[1], out3[1], out5[1], out6[1], out7[1], out8[1]};
Physical Volume(151) = {out4[1]};

